%{
#include <stdio.h>
#include <string.h>
#include <mem.h>
 
extern int yyparse( void );
extern int yylex ( void );
extern int yylex_destroy( void );
extern int yylineno;

static int yyerrors   = 0;


void yyerror(const char *str)
{
        fprintf(stderr,"line %d: error: %s\n", yylineno, str);
	yyerrors++;
}
 
int yywrap( void )
{
        return 1;
} 

int main( int argc, char **argv )
{
        int tok;
     
        if( yyparse() == 0 && yyerrors == 0 )
	{
		printf( "parsing succeeded\n" );
	} else
	{
		fprintf( stderr, "parsing failed\n" );
	}
        yylex_destroy();
	exit(0);
	return 0;
} 

%}

%token PLUS MINUS MUL DIV MOD OPEN CLOSE TOKERR
%token NUMBER

%start oneexpr

%%
oneexpr      :  expr
             ;

expr         : expr PLUS term
             | expr MINUS term
             | term
             ;

term         : term MUL factor
             | term DIV factor
             | term MOD factor
             | factor
             ;

factor       : NUMBER
             | OPEN expr CLOSE
             ;
