/*
  Integer Constant Expressions: Lex rules
 */
%{
#include <stdio.h>
#include <string.h>

#include <mem.h>

#include "types.h"
#include "parser.h"
%}
%%
[0-9]+                  yylval.n=atoi(yytext); return NUMBER;
\+			return PLUS;
-			return MINUS;
\*			return MUL;
\/			return DIV;
mod                     return MOD;
\(			return OPEN;
\)			return CLOSE;
[a-z][a-z0-9]*          yylval.s=strdup(yytext);return IDENT;
\n                      /* ignore end of line */;
[ \t]+                  /* ignore whitespace */;
.			return TOKERR;
%%
